package com.zt.plat.module.erp.service.erp;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.erp.controller.admin.erp.vo.ErpFactoryPageReqVO;
import com.zt.plat.module.erp.controller.admin.erp.vo.ErpFactoryRespVO;
import com.zt.plat.module.erp.controller.admin.erp.vo.ErpFactorySaveReqVO;
import com.zt.plat.module.erp.dal.dataobject.erp.ErpFactoryDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * ERP工厂 Service 接口
 *
 * @author 后台管理
 */
public interface ErpFactoryService {

    /**
     * 创建ERP工厂
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    ErpFactoryRespVO createErpFactory(@Valid ErpFactorySaveReqVO createReqVO);

    /**
     * 更新ERP工厂
     *
     * @param updateReqVO 更新信息
     */
    void updateErpFactory(@Valid ErpFactorySaveReqVO updateReqVO);

    /**
     * 删除ERP工厂
     *
     * @param id 编号
     */
    void deleteErpFactory(Long id);

    /**
    * 批量删除ERP工厂
    *
    * @param ids 编号
    */
    void deleteErpFactoryListByIds(List<Long> ids);

    /**
     * 获得ERP工厂
     *
     * @param id 编号
     * @return ERP工厂
     */
    ErpFactoryDO getErpFactory(Long id);

    /**
     * 获得ERP工厂分页
     *
     * @param pageReqVO 分页查询
     * @return ERP工厂分页
     */
    PageResult<ErpFactoryDO> getErpFactoryPage(ErpFactoryPageReqVO pageReqVO);

    List<ErpFactoryDO> getErpFactoryList();

    void callErpRfcInterface();

    void enableFactoryList(List<ErpFactoryRespVO> saveReqVOS);
}